Index: libexec/rtld-elf-cap/rtld_sandbox.c
===================================================================
--- libexec/rtld-elf-cap/rtld_sandbox.c	(.../stable/8)	(revision 0)
+++ libexec/rtld-elf-cap/rtld_sandbox.c	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,42 @@
+/*-
+ * Copyright (c) 2009 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ * 
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc. 
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD$");
+
+int
+ld_insandbox(void)
+{
+
+	return (1);
+}

Index: libexec/rtld-elf-cap/rtld_sandbox.h
===================================================================
--- libexec/rtld-elf-cap/rtld_sandbox.h	(.../stable/8)	(revision 0)
+++ libexec/rtld-elf-cap/rtld_sandbox.h	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,39 @@
+/*-
+ * Copyright (c) 2009 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ * 
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc. 
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef RTLD_SANDBOX_H
+#define	RTLD_SANDBOX_H
+
+int	ld_insandbox(void);
+
+#endif /* !RTLD_SANDBOX_H */

Index: libexec/rtld-elf-cap/Makefile
===================================================================
--- libexec/rtld-elf-cap/Makefile	(.../stable/8)	(revision 0)
+++ libexec/rtld-elf-cap/Makefile	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,55 @@
+# $FreeBSD$
+# $P4: //depot/projects/trustedbsd/capabilities/src/libexec/rtld-elf-cap/Makefile#21 $
+
+.include <bsd.own.mk>
+MK_SSP=		no
+
+PROG?=		ld-elf-cap.so.1
+SRCS=		rtld_start.S \
+		reloc.c rtld.c rtld_lock.c map_object.c \
+		malloc.c xmalloc.c debug.c \
+		crtbrand.c rtld_sandbox.c
+MAN=		rtld-elf-cap.1
+CSTD?=		gnu99
+CFLAGS+=	-Wall -DFREEBSD_ELF -DIN_RTLD -DIN_RTLD_CAP -g
+CFLAGS+=	-I${.CURDIR} -I${.CURDIR}/../rtld-elf/${MACHINE_ARCH} -I${.CURDIR}/../rtld-elf
+LDFLAGS+=	-nostdlib -Wl,-e,.rtld_start
+WARNS?=		2
+INSTALLFLAGS=	-C -b
+PRECIOUSPROG=
+BINDIR=		/libexec
+MLINKS=		rtld-elf-cap.1 ld-elf-cap.so.1.1
+
+CFLAGS+=	-fpic -DPIC
+LDFLAGS+=	-shared -Wl,-Bsymbolic
+DPADD=		${LIBC_PIC}
+LDADD=		-lc_pic -lssp_nonshared
+
+.if ${MACHINE_ARCH} != "ia64"
+.if ${MK_SYMVER} == "yes"
+LIBCDIR=	${.CURDIR}/../../lib/libc
+VERSION_DEF=	${LIBCDIR}/Versions.def
+SYMBOL_MAPS=	${.CURDIR}/../rtld-elf/Symbol.map
+VERSION_MAP=	Version.map
+LDFLAGS+=	-Wl,--version-script=${VERSION_MAP}
+
+${PROG}:	${VERSION_MAP}
+
+.if exists(${.CURDIR}/../rtld-elf/${MACHINE_ARCH}/Symbol.map)
+SYMBOL_MAPS+=	${.CURDIR}/../rtld-elf/${MACHINE_ARCH}/Symbol.map
+.endif
+.endif
+.endif
+
+SYMBOL_MAPS+=	${.CURDIR}/Symbol.map
+
+.if exists(${.CURDIR}/../rtld-elf/${MACHINE_ARCH}/Makefile.inc)
+.include "${.CURDIR}/../rtld-elf/${MACHINE_ARCH}/Makefile.inc"
+.endif
+
+.PATH: ${.CURDIR}/../rtld-elf
+.PATH: ${.CURDIR}/../rtld-elf/${MACHINE_ARCH}
+.PATH: ${.CURDIR}/../../lib/csu/common
+
+.include <bsd.symver.mk>
+.include <bsd.prog.mk>

Index: libexec/Makefile
===================================================================
--- libexec/Makefile	(.../stable/8)	(revision 201781)
+++ libexec/Makefile	(.../projects/capabilities8)	(revision 205872)
@@ -22,6 +22,7 @@
 	rpc.sprayd \
 	${_rshd} \
 	${_rtld-elf} \
+	${_rtld-elf-cap} \
 	save-entropy \
 	${_smrsh} \
 	talkd \
@@ -54,6 +55,7 @@
 
 .if !defined(NO_PIC) && !defined(NO_RTLD)
 _rtld-elf=	rtld-elf
+_rtld-elf-cap=	rtld-elf-cap
 .endif
 
 .if ${MK_RCMDS} != "no"
Index: libexec/rtld-elf/map_object.c
===================================================================
--- libexec/rtld-elf/map_object.c	(.../stable/8)	(revision 201781)
+++ libexec/rtld-elf/map_object.c	(.../projects/capabilities8)	(revision 205872)
@@ -44,7 +44,8 @@
 
 /*
  * Map a shared object into memory.  The "fd" argument is a file descriptor,
- * which must be open on the object and positioned at its beginning.
+ * which must be open on the object.
+ *
  * The "path" argument is a pathname that is used only for error messages.
  *
  * The return value is a pointer to a newly-allocated Obj_Entry structure
@@ -83,6 +84,7 @@
     Elf_Addr bss_vaddr;
     Elf_Addr bss_vlimit;
     caddr_t bss_addr;
+    int mmap_flags;
 
     hdr = get_elf_header(fd, path);
     if (hdr == NULL)
@@ -152,8 +154,10 @@
     mapsize = base_vlimit - base_vaddr;
     base_addr = hdr->e_type == ET_EXEC ? (caddr_t) base_vaddr : NULL;
 
-    mapbase = mmap(base_addr, mapsize, PROT_NONE, MAP_ANON | MAP_PRIVATE |
-      MAP_NOCORE, -1, 0);
+    mmap_flags = MAP_ANON | MAP_PRIVATE | MAP_NOCORE;
+    if (base_addr != NULL)
+	mmap_flags |= MAP_FIXED;
+    mapbase = mmap(base_addr, mapsize, PROT_NONE, mmap_flags, -1, 0);
     if (mapbase == (caddr_t) -1) {
 	_rtld_error("%s: mmap of entire address space failed: %s",
 	  path, strerror(errno));
Index: libexec/rtld-elf/rtld.c
===================================================================
--- libexec/rtld-elf/rtld.c	(.../stable/8)	(revision 201781)
+++ libexec/rtld-elf/rtld.c	(.../projects/capabilities8)	(revision 205872)
@@ -59,12 +59,26 @@
 #include "libmap.h"
 #include "rtld_tls.h"
 
+#ifdef IN_RTLD_CAP
+#include "rtld_sandbox.h"
+#endif
+
 #ifndef COMPAT_32BIT
+#ifdef IN_RTLD_CAP
+#define	PATH_RTLD	"/libexec/ld-elf-cap.so.1"
+#else
 #define PATH_RTLD	"/libexec/ld-elf.so.1"
+#endif
 #else
+#ifdef IN_RTLD_CAP
+#define	PATH_RTLD	"/libexex/ld-elf32-cap.so.1"
+#else
 #define PATH_RTLD	"/libexec/ld-elf32.so.1"
 #endif
+#endif
 
+#define INITIAL_FDLEN	16
+
 /* Types. */
 typedef void (*func_ptr_type)();
 typedef void * (*path_enum_proc) (const char *path, size_t len, void *arg);
@@ -92,19 +106,26 @@
 static bool donelist_check(DoneList *, const Obj_Entry *);
 static void errmsg_restore(char *);
 static char *errmsg_save(void);
+#ifdef IN_RTLD_CAP
+static void *find_capstart(const Obj_Entry *);
+#else
 static void *fill_search_info(const char *, size_t, void *);
 static char *find_library(const char *, const Obj_Entry *);
 static const char *gethints(void);
+#endif
 static void init_dag(Obj_Entry *);
 static void init_dag1(Obj_Entry *, Obj_Entry *, DoneList *);
 static void init_rtld(caddr_t);
 static void initlist_add_neededs(Needed_Entry *, Objlist *);
 static void initlist_add_objects(Obj_Entry *, Obj_Entry **, Objlist *);
+static void init_libdirs(void);
 static bool is_exported(const Elf_Sym *);
 static void linkmap_add(Obj_Entry *);
 static void linkmap_delete(Obj_Entry *);
 static int load_needed_objects(Obj_Entry *, int);
+#ifndef IN_RTLD_CAP
 static int load_preload_objects(void);
+#endif
 static Obj_Entry *load_object(const char *, const Obj_Entry *, int);
 static Obj_Entry *obj_from_addr(const void *);
 static void objlist_call_fini(Objlist *, bool, int *);
@@ -115,12 +136,16 @@
 static void objlist_push_head(Objlist *, Obj_Entry *);
 static void objlist_push_tail(Objlist *, Obj_Entry *);
 static void objlist_remove(Objlist *, Obj_Entry *);
+#ifndef IN_RTLD_CAP
 static void *path_enumerate(const char *, path_enum_proc, void *);
+#endif
 static int relocate_objects(Obj_Entry *, bool, Obj_Entry *);
 static int rtld_dirname(const char *, char *);
 static int rtld_dirname_abs(const char *, char *);
 static void rtld_exit(void);
+#ifndef IN_RTLD_CAP
 static char *search_library_path(const char *, const char *);
+#endif
 static const void **get_program_var_addr(const char *);
 static void set_program_var(const char *, const void *);
 static const Elf_Sym *symlook_default(const char *, unsigned long,
@@ -144,6 +169,8 @@
 static int  object_match_name(const Obj_Entry *, const char *);
 static void ld_utrace_log(int, void *, void *, size_t, int, const char *);
 
+int ld_libdirs(int *, int *);
+
 void r_debug_state(struct r_debug *, struct link_map *);
 
 /*
@@ -151,17 +178,25 @@
  */
 static char *error_message;	/* Message for dlerror(), or NULL */
 struct r_debug r_debug;		/* for GDB; */
+#ifndef IN_RTLD_CAP
 static bool libmap_disable;	/* Disable libmap */
 static char *libmap_override;	/* Maps to use in addition to libmap.conf */
+#endif
 static bool trust;		/* False for setuid and setgid programs */
 static bool dangerous_ld_env;	/* True if environment variables have been
 				   used to affect the libraries loaded */
 static char *ld_bind_now;	/* Environment variable for immediate binding */
 static char *ld_debug;		/* Environment variable for debugging */
+static int *ld_library_dirs = NULL; /* File descriptors of lib path (end: -1) */
+static int ld_library_dirs_done; /* ld_library_dirs has been initialized */
+static int ld_library_dirlen;	/* Capacity of ld_library_dirs */
+static int ld_library_dircount;	/* Number of entries in ld_library_dirs */
+#ifndef IN_RTLD_CAP
 static char *ld_library_path;	/* Environment variable for search path */
 static char *ld_preload;	/* Environment variable for libraries to
 				   load first */
 static char *ld_elf_hints_path;	/* Environment variable for alternative hints path */
+#endif
 static char *ld_tracing;	/* Called from ldd to print libs */
 static char *ld_utrace;		/* Use utrace() to log events. */
 static Obj_Entry *obj_list;	/* Head of linked list of shared objects */
@@ -214,6 +249,10 @@
     (func_ptr_type) &dl_iterate_phdr,
     (func_ptr_type) &_rtld_atfork_pre,
     (func_ptr_type) &_rtld_atfork_post,
+#ifdef IN_RTLD_CAP
+    (func_ptr_type) &ld_insandbox,
+#endif
+    (func_ptr_type) &ld_libdirs,
     NULL
 };
 
@@ -310,6 +349,11 @@
 func_ptr_type
 _rtld(Elf_Addr *sp, func_ptr_type *exit_proc, Obj_Entry **objp)
 {
+#ifdef IN_RTLD_CAP
+    struct stat sb;
+    Elf_Auxinfo aux_execfd;
+    void *capstart_ptr;
+#endif
     Elf_Auxinfo *aux_info[AT_COUNT];
     int i;
     int argc;
@@ -352,10 +396,46 @@
     assert(aux_info[AT_BASE] != NULL);
     init_rtld((caddr_t) aux_info[AT_BASE]->a_un.a_ptr);
 
-    __progname = obj_rtld.path;
+    /* XXXRW: Need to do something about program names in capability mode. */
+    __progname = obj_rtld.path; /* TODO: binary name */
     argv0 = argv[0] != NULL ? argv[0] : "(null)";
     environ = env;
 
+#ifdef IN_RTLD_CAP
+    /*
+     * In capability mode, the kernel has executed ld-elf-cap.so directly,
+     * and the parent has passed the executable it wants us to run as a file
+     * descriptor.  The kernel doesn't know this, so rewrite our auxilary
+     * arguments so the remainder of rtld thinks the kernel passed the file
+     * descriptor using AT_EXECFD.
+     */
+    if (aux_info[AT_EXECFD] == NULL) {
+	const char *ld_binary;
+	char *endp;
+	long ld_binary_fd;
+
+	ld_binary = getenv(LD_ "BINARY");
+	if (ld_binary == NULL) {
+	    _rtld_error("LD_BINARY unset; aborting");
+	    die();
+	}
+	ld_binary_fd = strtol(ld_binary, &endp, 10);
+	if (ld_binary_fd < 0 || ld_binary_fd > __INT_MAX || *endp != 0) {
+	    _rtld_error("LD_BINARY invalid");
+	    die();
+	}
+	if (fstat(ld_binary_fd, &sb) < 0) {
+	    __progname = "ld-elf-cap.so";
+	    _rtld_error("executable file descriptor unusable");
+	    die();
+	}
+	bzero(&aux_execfd, sizeof(aux_execfd));
+	aux_execfd.a_type = AT_EXECFD;
+	aux_execfd.a_un.a_val = ld_binary_fd;
+	aux_info[AT_EXECFD] = &aux_execfd;
+    }
+#endif
+
     trust = !issetugid();
 
     ld_bind_now = getenv(LD_ "BIND_NOW");
@@ -372,21 +452,33 @@
 		_rtld_error("environment corrupt; aborting");
 		die();
 	}
+#ifdef IN_RTLD_CAP
+	unsetenv(LD_ "LIBCACHE");
+#endif
     }
     ld_debug = getenv(LD_ "DEBUG");
+#ifndef IN_RTLD_CAP
     libmap_disable = getenv(LD_ "LIBMAP_DISABLE") != NULL;
     libmap_override = getenv(LD_ "LIBMAP");
     ld_library_path = getenv(LD_ "LIBRARY_PATH");
     ld_preload = getenv(LD_ "PRELOAD");
     ld_elf_hints_path = getenv(LD_ "ELF_HINTS_PATH");
-    dangerous_ld_env = libmap_disable || (libmap_override != NULL) ||
+#endif
+    dangerous_ld_env =
+#ifdef IN_RTLD_CAP
+	1;
+#else
+	libmap_disable || (libmap_override != NULL) ||
 	(ld_library_path != NULL) || (ld_preload != NULL) ||
 	(ld_elf_hints_path != NULL);
+#endif
     ld_tracing = getenv(LD_ "TRACE_LOADED_OBJECTS");
     ld_utrace = getenv(LD_ "UTRACE");
 
+#ifndef IN_RTLD_CAP
     if ((ld_elf_hints_path == NULL) || strlen(ld_elf_hints_path) == 0)
 	ld_elf_hints_path = _PATH_ELF_HINTS;
+#endif
 
     if (ld_debug != NULL && *ld_debug != '\0')
 	debug = 1;
@@ -403,7 +495,9 @@
 	int fd = aux_info[AT_EXECFD]->a_un.a_val;
 	dbg("loading main program");
 	obj_main = map_object(fd, argv0, NULL);
+#ifndef IN_RTLD_CAP
 	close(fd);
+#endif
 	if (obj_main == NULL)
 	    die();
     } else {				/* Main program already loaded. */
@@ -476,12 +570,14 @@
     sym_zero.st_shndx = SHN_UNDEF;
     sym_zero.st_value = -(uintptr_t)obj_main->relocbase;
 
+#ifndef IN_RTLD_CAP
     if (!libmap_disable)
         libmap_disable = (bool)lm_init(libmap_override);
 
     dbg("loading LD_PRELOAD libraries");
     if (load_preload_objects() == -1)
 	die();
+#endif
     preload_tail = obj_tail;
 
     dbg("loading needed objects");
@@ -555,7 +651,22 @@
     /* Return the exit procedure and the program entry point. */
     *exit_proc = rtld_exit;
     *objp = obj_main;
+
+#ifdef IN_RTLD_CAP
+    /*
+     * If the object provides an alternative capability-mode specific entry
+     * point, prefer that to the ELF default entry point.  Otherwise, use the
+     * ELF default.
+     */
+    capstart_ptr = find_capstart(obj_main);
+    if (capstart_ptr == NULL) {
+	_rtld_error("_capstart not found; has the binary been compiled with -rdynamic?");
+	die();
+    }
+    return (func_ptr_type) capstart_ptr;
+#else
     return (func_ptr_type) obj_main->entry;
+#endif
 }
 
 Elf_Addr
@@ -722,6 +833,26 @@
     return (res4);
 }
 
+#ifdef IN_RTLD_CAP
+static void *
+find_capstart(const Obj_Entry *obj)
+{
+    const char *capstart_str = "_capstart";
+    const Elf_Sym *def;
+    const Obj_Entry *defobj;
+    unsigned long hash;
+
+    hash = elf_hash(capstart_str);
+    def = symlook_default(capstart_str, hash, obj, &defobj, NULL,
+	SYMLOOK_IN_PLT);
+    if (def == NULL)
+	return (NULL);
+    if (ELF_ST_TYPE(def->st_info) != STT_FUNC)
+	return (NULL);
+    return (make_function_pointer(def, defobj));
+}
+#endif
+
 static void
 die(void)
 {
@@ -1104,7 +1235,28 @@
     return h;
 }
 
+#ifdef IN_RTLD_CAP
 /*
+ * Find the library with the given name, and return an open file descriptor
+ * to it.
+ */
+static int
+find_library_fd(const char *name)
+{
+    int fd, i;
+
+    if (!ld_library_dirs_done)
+	init_libdirs();
+    for (i = 0; i < ld_library_dircount; i++) {
+	fd = openat(ld_library_dirs[i], name, O_RDONLY);
+	if (fd >= 0)
+	    return (fd);
+    }
+    return (-1);
+}
+
+#else
+/*
  * Find the library with the given name, and return its full pathname.
  * The returned string is dynamically allocated.  Generates an error
  * message and returns NULL if the library cannot be found.
@@ -1157,6 +1309,7 @@
     }
     return NULL;
 }
+#endif
 
 /*
  * Given a symbol number in a referencing object, find the corresponding
@@ -1234,6 +1387,7 @@
     return def;
 }
 
+#ifndef IN_RTLD_CAP
 /*
  * Return the search path from the ldconfig hints file, reading it if
  * necessary.  Returns NULL if there are problems with the hints file,
@@ -1272,6 +1426,7 @@
     }
     return hints[0] != '\0' ? hints : NULL;
 }
+#endif
 
 static void
 init_dag(Obj_Entry *root)
@@ -1325,10 +1480,16 @@
 	objtmp.dynamic = rtld_dynamic(&objtmp);
 	digest_dynamic(&objtmp, 1);
 	assert(objtmp.needed == NULL);
+#if 0
+	/*
+	 * XXXRW: For reasons as yet undetermined, this assertion fires in
+	 * capability mode.
+	 */
 #if !defined(__mips__)
 	/* MIPS and SH{3,5} have a bogus DT_TEXTREL. */
 	assert(!objtmp.textrel);
 #endif
+#endif
 
 	/*
 	 * Temporarily put the dynamic linker entry into the object list, so
@@ -1451,6 +1612,7 @@
     return 0;
 }
 
+#ifndef IN_RTLD_CAP
 static int
 load_preload_objects(void)
 {
@@ -1476,6 +1638,7 @@
     LD_UTRACE(UTRACE_PRELOAD_FINISHED, NULL, NULL, 0, 0, NULL);
     return 0;
 }
+#endif
 
 /*
  * Load a shared object into memory, if it is not already loaded.
@@ -1495,6 +1658,18 @@
 	if (object_match_name(obj, name))
 	    return obj;
 
+#ifdef IN_RTLD_CAP
+    if (strchr(name, '/') != NULL) {
+	_rtld_error("Paths to shared objects not supported \"%s\"", name);
+	return NULL;
+    }
+    path = xstrdup(name);
+    if ((fd = find_library_fd(path)) < 0) {
+	_rtld_error("Unable to find \"%s\" in LD_LIBRARY_DIRS", path);
+	free(path);
+	return NULL;
+    }
+#else
     path = find_library(name, refobj);
     if (path == NULL)
 	return NULL;
@@ -1512,22 +1687,29 @@
 	free(path);
 	return NULL;
     }
+#endif
     if (fstat(fd, &sb) == -1) {
 	_rtld_error("Cannot fstat \"%s\"", path);
+#ifndef IN_RTLD_CAP
 	close(fd);
+#endif
 	free(path);
 	return NULL;
     }
     for (obj = obj_list->next;  obj != NULL;  obj = obj->next) {
 	if (obj->ino == sb.st_ino && obj->dev == sb.st_dev) {
+#ifndef IN_RTLD_CAP
 	    close(fd);
+#endif
 	    break;
 	}
     }
     if (obj != NULL) {
 	object_add_name(obj, name);
 	free(path);
+#ifndef IN_RTLD_CAP
 	close(fd);
+#endif
 	return obj;
     }
     if (flags & RTLD_LO_NOLOAD)
@@ -1537,7 +1719,9 @@
     obj = do_load_object(fd, name, path, &sb, flags);
     if (obj == NULL)
 	free(path);
+#ifndef IN_RTLD_CAP
     close(fd);
+#endif
 
     return obj;
 }
@@ -1831,11 +2015,14 @@
     dbg("rtld_exit()");
     objlist_call_fini(&list_fini, true, &lockstate);
     /* No need to remove the items from the list, since we are exiting. */
+#ifndef IN_RTLD_CAP
     if (!libmap_disable)
         lm_fini();
+#endif
     wlock_release(rtld_bind_lock, lockstate);
 }
 
+#ifndef IN_RTLD_CAP
 static void *
 path_enumerate(const char *path, path_enum_proc callback, void *arg)
 {
@@ -1868,6 +2055,7 @@
 
     return (NULL);
 }
+#endif
 
 struct try_library_args {
     const char	*name;
@@ -1903,6 +2091,7 @@
     return (NULL);
 }
 
+#ifndef IN_RTLD_CAP
 static char *
 search_library_path(const char *name, const char *path)
 {
@@ -1923,8 +2112,136 @@
 
     return (p);
 }
+#endif
 
+/*
+ * Add a file descriptor to ld_library_dirs.
+ *
+ * XXX: This may be called from either the rtld startup code, or from
+ * ld_libdirs.  We have no way to distinguish them on error, so die()
+ * unconditionally.  Perhaps the latter case should allow graceful failure.
+ *
+ * XXX: Synchronization?
+ */
+static void
+add_libdir_fd(int fd)
+{
+
+    /* Initialize the FD list. */
+    if (!ld_library_dirs_done) {
+	ld_library_dirlen = INITIAL_FDLEN;
+	ld_library_dircount = 0;
+	ld_library_dirs = xmalloc(ld_library_dirlen * sizeof(int));
+	ld_library_dirs_done = 1;
+    }
+
+    /* Do we need to grow? */
+    if (ld_library_dirlen == ld_library_dircount) {
+	ld_library_dirlen *= 2;
+	ld_library_dirs = realloc(ld_library_dirs,
+	    ld_library_dirlen * sizeof(int));
+	if (ld_library_dirs == NULL) {
+	    _rtld_error("add_libdir_fd: realloc failed");
+	    die();
+	}
+    }
+
+    /* Add the new library directory fd to the end. */
+    ld_library_dirs[ld_library_dircount] = fd;
+    ld_library_dircount++;
+}
+
+/*
+ * Add file descriptors for a path list (e.g. '/lib:/usr/lib') to
+ * ld_library_dirs.
+ */
+static void
+add_libdir_paths(const char *path)
+{
+
+    if (path == NULL)
+	return;
+
+    char *pathcopy, *dirname, *tokcontext;
+    int pathlen = strnlen(path, PATH_MAX);
+
+    pathcopy = malloc(pathlen + 1);
+    strncpy(pathcopy, path, pathlen + 1);
+
+    for (dirname = strtok_r(pathcopy, ":", &tokcontext); dirname;
+	dirname = strtok_r(NULL, ":", &tokcontext)) {
+	struct try_library_args arg;
+	int fd;
+
+	arg.name = "";
+	arg.namelen = 0;
+	arg.buffer = xmalloc(PATH_MAX);
+	arg.buflen = PATH_MAX;
+
+	if (try_library_path(dirname, strnlen(dirname, PATH_MAX), &arg)) {
+	    fd = open(dirname, O_RDONLY);
+	} else {
+	    /* 'dirname' is not a directory path; perhaps it's a descriptor? */
+	    fd = (int) strtol(dirname, NULL, 0);
+	    if ((fd == 0) && (errno == 0))
+		continue;
+	}
+
+	if (fd >= 0)
+	    add_libdir_fd(fd);
+    }
+
+    free(pathcopy);
+}
+
+/*
+ * Build the list of library file descriptors.
+ */
+static void
+init_libdirs(void)
+{
+#ifdef IN_RTLD_CAP
+    char *envvar = getenv(LD_ "LIBRARY_DIRS");
+
+    if (envvar == NULL)
+	err(-1, "No %s set in capability mode", LD_ "LIBRARY_DIRS");
+
+    add_libdir_paths(envvar);
+#else /* !IN_RTLD_CAP */
+    /* Look for directories a la find_library (TODO: refactor!). */
+    add_libdir_paths(ld_library_path);
+    add_libdir_paths(gethints());
+    add_libdir_paths(STANDARD_LIBRARY_PATH);
+#endif
+}
+
+/*
+ * Return an array of file descriptors for the library search paths.
+ *
+ * XXX: synchronization of ld_library_dirs?
+ */
 int
+ld_libdirs(int *fds, int *fdcount)
+{
+
+    if (fdcount == NULL)
+	return (-1);
+    else if (fds == NULL) {
+	*fdcount = -1;
+	return (-1);
+    }
+    if (!ld_library_dirs_done)
+	init_libdirs();
+    if (*fdcount < ld_library_dircount) {
+	*fdcount = ld_library_dircount;
+	return (-1);
+    }
+    *fdcount = ld_library_dircount;
+    memcpy(fds, ld_library_dirs, ld_library_dircount * sizeof(int));
+    return (0);
+}
+
+int
 dlclose(void *handle)
 {
     Obj_Entry *root;
@@ -2367,6 +2684,7 @@
     char	*strspace;
 };
 
+#ifndef IN_RTLD_CAP
 static void *
 fill_search_info(const char *dir, size_t dirlen, void *param)
 {
@@ -2393,19 +2711,23 @@
 
     return (NULL);
 }
+#endif
 
 static int
 do_search_info(const Obj_Entry *obj, int request, struct dl_serinfo *info)
 {
     struct dl_serinfo _info;
+#ifndef IN_RTLD_CAP
     struct fill_search_info_args args;
 
     args.request = RTLD_DI_SERINFOSIZE;
     args.serinfo = &_info;
+#endif
 
     _info.dls_size = __offsetof(struct dl_serinfo, dls_serpath);
     _info.dls_cnt  = 0;
 
+#ifndef IN_RTLD_CAP
     path_enumerate(ld_library_path, fill_search_info, &args);
     path_enumerate(obj->rpath, fill_search_info, &args);
     path_enumerate(gethints(), fill_search_info, &args);
@@ -2417,12 +2739,14 @@
 	info->dls_cnt = _info.dls_cnt;
 	return (0);
     }
+#endif
 
     if (info->dls_cnt != _info.dls_cnt || info->dls_size != _info.dls_size) {
 	_rtld_error("Uninitialized Dl_serinfo struct passed to dlinfo()");
 	return (-1);
     }
 
+#ifndef IN_RTLD_CAP
     args.request  = RTLD_DI_SERINFO;
     args.serinfo  = info;
     args.serpath  = &info->dls_serpath[0];
@@ -2443,6 +2767,7 @@
     args.flags = LA_SER_DEFAULT;
     if (path_enumerate(STANDARD_LIBRARY_PATH, fill_search_info, &args) != NULL)
 	return (-1);
+#endif
     return (0);
 }
 
Index: libexec/rtld-elf/Makefile
===================================================================
--- libexec/rtld-elf/Makefile	(.../stable/8)	(revision 201781)
+++ libexec/rtld-elf/Makefile	(.../projects/capabilities8)	(revision 205872)
@@ -11,7 +11,7 @@
 CSTD?=		gnu99
 CFLAGS+=	-Wall -DFREEBSD_ELF -DIN_RTLD
 CFLAGS+=	-I${.CURDIR}/${MACHINE_ARCH} -I${.CURDIR}
-LDFLAGS+=	-nostdlib -e .rtld_start
+LDFLAGS+=	-nostdlib -Wl,-e,.rtld_start
 INSTALLFLAGS=	-C -b
 PRECIOUSPROG=
 BINDIR=		/libexec

Index: sys/arm/arm/sys_machdep.c
===================================================================
--- sys/arm/arm/sys_machdep.c	(.../stable/8)	(revision 201781)
+++ sys/arm/arm/sys_machdep.c	(.../projects/capabilities8)	(revision 205872)
@@ -104,6 +104,10 @@
 {
 	int error;
 
+	/*
+	 * XXXRW: As new operations are added here, check that they are safe
+	 * in capability mode.
+	 */
 	switch (uap->op) {
 	case ARM_SYNC_ICACHE : 
 		error = arm32_sync_icache(td, uap->parms);
Index: sys/sparc64/sparc64/sys_machdep.c
===================================================================
--- sys/sparc64/sparc64/sys_machdep.c	(.../stable/8)	(revision 201781)
+++ sys/sparc64/sparc64/sys_machdep.c	(.../projects/capabilities8)	(revision 205872)
@@ -53,6 +53,10 @@
 {
 	int error;
 
+	/*
+	 * XXXRW: As new operations are added here, check that they are safe
+	 * in capability mode.
+	 */
 	mtx_lock(&Giant);
 	switch (uap->op) {
 	case SPARC_SIGTRAMP_INSTALL:
Index: sys/conf/NOTES
===================================================================
--- sys/conf/NOTES	(.../stable/8)	(revision 201781)
+++ sys/conf/NOTES	(.../projects/capabilities8)	(revision 205872)
@@ -1099,6 +1099,9 @@
 options 	NTFS_ICONV
 options 	UDF_ICONV
 
+# Support for process descriptors
+options 	PROCDESC
+
 
 #####################################################################
 # POSIX P1003.1B
@@ -1120,6 +1123,9 @@
 # Support for BSM audit
 options 	AUDIT
 
+# Support for kernel capabilities
+options		CAPABILITIES
+
 # Support for Mandatory Access Control (MAC):
 options 	MAC
 options 	MAC_BIBA
Index: sys/conf/files
===================================================================
--- sys/conf/files	(.../stable/8)	(revision 201781)
+++ sys/conf/files	(.../projects/capabilities8)	(revision 205872)
@@ -2051,8 +2051,10 @@
 kern/subr_turnstile.c		standard
 kern/subr_unit.c		standard
 kern/subr_witness.c		optional witness
+kern/sys_capability.c		standard
 kern/sys_generic.c		standard
 kern/sys_pipe.c			standard
+kern/sys_procdesc.c		standard
 kern/sys_process.c		standard
 kern/sys_socket.c		standard
 kern/syscalls.c			optional witness | invariants | kdtrace_hooks
Index: sys/conf/options
===================================================================
--- sys/conf/options	(.../stable/8)	(revision 201781)
+++ sys/conf/options	(.../projects/capabilities8)	(revision 205872)
@@ -63,6 +63,7 @@
 ADAPTIVE_LOCKMGRS
 ALQ
 AUDIT		opt_global.h
+CAPABILITIES	opt_capabilities.h
 CODA_COMPAT_5	opt_coda.h
 COMPAT_43	opt_compat.h
 COMPAT_43TTY	opt_compat.h
@@ -143,6 +144,7 @@
 PPC_PROBE_CHIPSET	opt_ppc.h
 PPS_SYNC	opt_ntp.h
 PREEMPTION	opt_sched.h
+PROCDESC	opt_procdesc.h
 QUOTA
 SCHED_4BSD	opt_sched.h
 SCHED_STATS	opt_sched.h
Index: sys/gnu/fs/xfs/xfs_dfrag.c
===================================================================
--- sys/gnu/fs/xfs/xfs_dfrag.c	(.../stable/8)	(revision 201781)
+++ sys/gnu/fs/xfs/xfs_dfrag.c	(.../projects/capabilities8)	(revision 205872)
@@ -46,6 +46,7 @@
 #include "xfs_mac.h"
 #include "xfs_rw.h"
 
+#include <sys/capability.h>
 #include <sys/file.h>
 
 /*
@@ -79,7 +80,8 @@
 	}
 
 	/* Pull information for the target fd */
-	if (fgetvp(td, (int)sxp->sx_fdtarget, &bvp) != 0) {
+	if (fgetvp(td, (int)sxp->sx_fdtarget, CAP_READ | CAP_WRITE, &bvp)
+	    != 0) {
 		error = XFS_ERROR(EINVAL);
 		goto error0;
 	}
@@ -91,7 +93,8 @@
 		goto error0;
 	}
 
-	if (fgetvp(td, (int)sxp->sx_fdtmp, &btvp) != 0) {
+	if (fgetvp(td, (int)sxp->sx_fdtmp, CAP_READ | CAP_WRITE, &btvp) !=
+	    0) {
 		error = XFS_ERROR(EINVAL);
 		goto error0;
 	}
Index: sys/ufs/ffs/ffs_alloc.c
===================================================================
--- sys/ufs/ffs/ffs_alloc.c	(.../stable/8)	(revision 201781)
+++ sys/ufs/ffs/ffs_alloc.c	(.../projects/capabilities8)	(revision 205872)
@@ -62,9 +62,11 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
+#include "opt_capabilities.h"
 #include "opt_quota.h"
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/systm.h>
 #include <sys/bio.h>
 #include <sys/buf.h>
@@ -2411,7 +2413,8 @@
 		return (error);
 	if (cmd.version != FFS_CMD_VERSION)
 		return (ERPCMISMATCH);
-	if ((error = getvnode(curproc->p_fd, cmd.handle, &fp)) != 0)
+	if ((error = getvnode_cap(curproc->p_fd, cmd.handle, CAP_FSCK, &fp))
+	    != 0)
 		return (error);
 	vn_start_write(fp->f_data, &mp, V_WAIT);
 	if (mp == 0 || strncmp(mp->mnt_stat.f_fstypename, "ufs", MFSNAMELEN)) {
